<?php
require_once 'DB/DataObject.php';
class PEAR_Server_Channels_DBDataObject
{
    function PEAR_Server_Channels($config = array())
    {
        $options = &PEAR::getStaticProperty('DB_DataObject','options');
        $options = array_merge(array(
            'database'         => 'mysql://pear@localhost/pearserver',
            'schema_location'  => '@data-dir@/PEAR_Server/DBDataObject',
            'class_location'   => '@php-dir@/PEAR/Server/Backend/DBDataObject/',
            'require_prefix'   => 'PEAR/Server/Backend/DBDataObject/',
            'class_prefix'     => 'PEAR_Server_Backend_DBDataObject_',
        ), $config);
    }

    /**
     * Add a channel to be handled by this PEAR server
     * @param PEAR_ChannelFile
     */
    function addLocalChannel($channelobj)
    {
        $channel = &DB_DataObject::factory('channels');
        $channel->channel = $channelobj->getName();
        $channel->summary = $channelobj->getSummary();
        $channel->server = $channelobj->getServer();
        $channel->packagenameregex = $channelobj->getPackagenameRegex();
        return $channel->insert();
    }

    /**
     * @param string
     * @return boolean
     */
    function validLocalChannel($channel)
    {
        $chan = &DB_DataObject::factory('channels');
        $chan->channel = $channel;
        return $chan->find();
    }

    /**
     * @param string
     * @return false|PEAR_ChannelFile
     */
    function getChannel($channel)
    {
        $chan = &DB_DataObject::factory('channels');
        $chan->channel = $channel;
        $test = $chan->find();
        if (!$test) {
            return false;
        }
        $channel = new PEAR_ChannelFile;
        $channel->setName($chan->channel);
        $channel->setSummary($chan->summary);
        $channel->setServer($chan->server);
        $channel->setPackagenameRegex($chan->packagenameregex);
        if (!$channel->validate()) {
            return false;
        }
        return $channel;
    }
}
?>