<?php
class Server_mysqlinstall_postinstall
{
    var $_pkg;
    var $_ui;
    var $_config;
    var $_registry;
    var $db;
    var $user;
    var $password;
    var $lastversion;
    var $channel;
    var $alias;
    var $channelxml;
    var $handle;
    var $docroot;
    function init(&$config, &$pkg)
    {
        $this->_config = &$config;
        $this->_registry = &$config->getRegistry();
        $this->_ui = &PEAR_Frontend::singleton();
        $this->_pkg = &$pkg;
        return true;
    }

    function run($answers, $phase)
    {
        switch ($phase) {
            case 'questionCreate' :
                if ($answers['doit'] != 'yes') {
                    return false;
                }
                return true;
            break;
            case 'databaseCreate' :
                return $this->createDatabase($answers);
            break;
            case 'channelCreate' :
                return $this->createChannel($answers);
            break;
            case 'administrator' :
                return $this->setupAdministrator($answers);
            break;
            case 'files' :
                return $this->createServerFiles($answers);
            break;
            case '_undoOnError' :
                // answers contains paramgroups that succeeded in reverse order
                foreach ($answers as $group) {
                    switch ($group) {
                        case 'questionCreate' :
                        break;
                        case 'databaseCreate' :
                            if ($this->lastversion) {
                                // don't uninstall the database if it had already existed
                                break;
                            }
                            $conn = $this->getDBConnection();
                            if (!$conn) {
                                break;
                            }
                            if (extension_loaded('mysqli')) {
                                $query = mysqli_select_db($conn, $this->db);
                            } else {
                                $query = mysql_select_db($this->db, $conn);
                            }
                            if ($query) {
                                if (extension_loaded('mysqli')) {
                                    $res = @mysqli_query($conn, 'DROP DATABASE ' . $this->db);
                                } else {
                                    $res = @mysql_query('DROP DATABASE ' . $this->db);
                                }
                            }
                            $this->closeDB($conn);
                        break;
                        case 'channelCreate' :
                            $conn = $this->getDBConnection();
                            if (!$conn) {
                                break;
                            }
                            if (extension_loaded('mysqli')) {
                                $query = mysqli_select_db($conn, $this->db);
                            } else {
                                $query = mysql_select_db($this->db, $conn);
                            }
                            if ($query) {
                                if (extension_loaded('mysqli')) {
                                    $res = @mysqli_query($conn, 'DELETE FROM channels WHERE channel="' .
                                        $this->channel . '"');
                                } else {
                                    $res = @mysql_query('DELETE FROM channels WHERE channel="' .
                                        $this->channel . '"');
                                }
                            }
                            $this->closeDB($conn);
                        break;
                        case 'administrator' :
                            $conn = $this->getDBConnection();
                            if (!$conn) {
                                break;
                            }
                            if (extension_loaded('mysqli')) {
                                $query = mysqli_select_db($conn, $this->db);
                            } else {
                                $query = mysql_select_db($this->db, $conn);
                            }
                            if ($query) {
                                if (extension_loaded('mysqli')) {
                                    $res = @mysqli_query($conn, 'DELETE FROM handles WHERE handle="' .
                                        $this->handle . '"');
                                } else {
                                    $res = @mysql_query('DELETE FROM handles WHERE handle="' .
                                        $this->handle . '"');
                                }
                            }
                            $this->closeDB($conn);
                        break;
                        case 'files' :
                            if (file_exists($this->docroot . DIRECTORY_SEPARATOR . 'xmlrpc.php')) {
                                unlink($this->docroot . DIRECTORY_SEPARATOR . 'xmlrpc.php');
                            }
                            if (file_exists($this->docroot . DIRECTORY_SEPARATOR . $this->frontend)) {
                                unlink($this->docroot . DIRECTORY_SEPARATOR . $this->frontend);
                            }
                        break;
                    }
                }
            break;
        }
    }

    function getDBConnection()
    {
        if (extension_loaded('mysqli')) {
            $conn = @mysqli_connect('localhost', $this->user, $this->password);
        } else {
            $conn = @mysql_connect('localhost', $this->user, $this->password);
        }
        if (!$conn) {
            $this->_ui->outputData('Connection to mysql server failed');
            return false;
        }
        return $conn;
    }

    function closeDB($conn)
    {
        if (extension_loaded('mysqli')) {
            mysqli_close($conn);
        } else {
            mysql_close($conn);
        }
    }

    function createDatabase($answers)
    {
        $this->db = $answers['database'];
        $this->user = $answers['user'];
        $this->password = $answers['password'];
        $conn = $this->getDBConnection();
        if (!$conn) {
            return false;
        }
        if (extension_loaded('mysqli')) {
            $query = mysqli_select_db($conn, $this->db);
        } else {
            $query = mysql_select_db($this->db, $conn);
        }
        if ($query) {
            $this->_ui->outputData('database is already setup');
            $this->closeDB($conn);
            return true;
        }
        if (extension_loaded('mysqli')) {
            $query = mysqli_query($conn, 'CREATE DATABASE ' . $answers['database']);
        } else {
            $query = mysql_query('CREATE DATABASE ' . $answers['database'], $conn);
        }
        if ($query) {
            if (extension_loaded('mysqli')) {
                $query = mysqli_select_db($conn, $answers['database']);
            } else {
                $query = mysql_select_db($answers['database'], $conn);
            }
            if ($query) {
                $contents = explode(';',
                    file_get_contents('/var/www/project-p/webdb/lib/data/PEAR_Server/data/pearserver.sql'));
                if (count($contents) > 1) {
                    foreach ($contents as $indquery) {
                        if (!strpos($indquery, 'CREATE')) {
                            continue;
                        }
                        if (extension_loaded('mysqli')) {
                            $query = mysqli_query($conn, $indquery);
                        } else {
                            $query = mysql_query($indquery, $conn);
                        }
                        if (!$query) {
                            break;
                        }
                    }
                    if ($query) {
                        $this->_ui->outputData('Creating tables succeeded');
                        $this->closeDB($conn);
                        return true;
                    } else {
                        if (extension_loaded('mysqli')) {
                            $this->_ui->outputData(mysqli_error($conn));
                        } else {
                            $this->_ui->outputData(mysql_error());
                        }
                        $this->_ui->outputData('Creating tables failed');
                    }
                } else {
                    $this->_ui->outputData('Could not open the sql for table creation');
                }
            } else {
                if (extension_loaded('mysqli')) {
                    $this->_ui->outputData(mysqli_error($conn));
                } else {
                    $this->_ui->outputData(mysql_error());
                }
                $this->_ui->outputData('Could not select database for creating');
            }
        } else {
            $this->_ui->outputData('Database creation failed' .
                (extension_loaded('mysqli') ? mysqli_error($conn) : mysql_error()));
        }
        $this->closeDB($conn);
        return false;
    }

    function createChannel($answers)
    {
        $this->channel = $answers['name'];
        $this->alias = $answers['alias'];
        include_once 'DB/DataObject.php';
        if (!class_exists('DB_DataObject')) {
            $this->_ui->outputData('DB_DataObject is required to use PEAR_Server');
            return false;
        }
        $options = &PEAR::getStaticProperty('DB_DataObject','options');
        $type = extension_loaded('mysqli') ? 'mysqli' : 'mysql';
        $phpdir = str_replace('\\', '/', '/var/www/project-p/webdb/lib');
        $datadir = str_replace('\\', '/', '/var/www/project-p/webdb/lib/data');
        $options = array(
            'database'         => $type . '://' . $this->user . ':' . $this->password .
                '@localhost/' . $this->db,
            'schema_location'  => $datadir . '/PEAR_Server/data/DBDataObject',
            'class_location'   => $phpdir . '/PEAR/Server/Backend/DBDataObject/',
            'require_prefix'   => 'PEAR/Server/Backend/DBDataObject/',
            'class_prefix'     => 'PEAR_Server_Backend_DBDataObject_',
        );
        $dbo = DB_DataObject::factory('channels');
        $dbo->channel = $answers['name'];
        $dbo->summary = $answers['summary'];
        $dbo->alias = $answers['alias'];
        if (!$dbo->find()) {
            $dbo->channel = $answers['name'];
            $dbo->summary = $answers['summary'];
            $dbo->alias = $answers['alias'];
            if (!$dbo->insert()) {
                $this->_ui->outputData('Creation of channel failed');
                return false;
            }
        }
        include_once 'PEAR/ChannelFile.php';
        $this->_ui->outputData('adding channel to local registry');
        $chan = new PEAR_ChannelFile;
        $chan->setName($answers['name']);
        $chan->setSummary($answers['summary']);
        $chan->setAlias($answers['alias']);
        $chan->setDefaultPEARProtocols();
        if (!$this->_registry->channelExists($answers['name'])) {
            $this->_registry->addChannel($chan);
        } else {
            $this->_registry->updateChannel($chan);
        }
        $xml = $chan->toXml();
        $this->channelxml = $xml;
        return true;
    }

    function setupAdministrator($answers)
    {
        include_once 'DB/DataObject.php';
        if (!class_exists('DB_DataObject')) {
            $this->_ui->outputData('DB_DataObject is required to use PEAR_Server');
            return false;
        }
        $options = &PEAR::getStaticProperty('DB_DataObject','options');
        $type = extension_loaded('mysqli') ? 'mysqli' : 'mysql';
        $phpdir = str_replace('\\', '/', '/var/www/project-p/webdb/lib');
        $datadir = str_replace('\\', '/', '/var/www/project-p/webdb/lib/data');
        $options = array(
            'database'         => $type . '://' . $this->user . ':' . $this->password .
                '@localhost/' . $this->db,
            'schema_location'  => $datadir . '/PEAR_Server/data/DBDataObject',
            'class_location'   => $phpdir . '/PEAR/Server/Backend/DBDataObject/',
            'require_prefix'   => 'PEAR/Server/Backend/DBDataObject/',
            'class_prefix'     => 'PEAR_Server_Backend_DBDataObject_',
        );
        $this->_ui->outputData('Add the primary administrator');
        $dbo = DB_DataObject::factory('handles');
        $dbo->handle = $answers['handle'];
        $this->handle = $dbo->handle;
        PEAR::pushErrorHandling(PEAR_ERROR_RETURN);
        if (!$dbo->find()) {
            $dbo->name = $answers['name'];
            $dbo->email = $answers['email'];
            $dbo->password = md5($answers['password']);
            $dbo->admin = 1;
            $a = $dbo->insert();
        } else {
            $dbo->name = $answers['name'];
            $dbo->email = $answers['email'];
            $dbo->password = md5($answers['password']);
            $dbo->admin = 1;
            $a = $dbo->update();
        }
        PEAR::popErrorHandling();
        if ($a === false || PEAR::isError($a)) {
            $this->_ui->outputData('Creation of admin user failed');
            if (PEAR::isError($a)) {
                PEAR::raiseError($a);
            }
            return false;
        } else {
            $this->_ui->outputData('Creation of admin user succeeded');
            return true;
        }
    }

    function createServerFiles($answers)
    {
        $this->docroot = $answers['docroot'];
        $this->frontend = $answers['frontendphp'];
        include_once 'System.php';
        if (!class_exists('System')) {
            $this->_ui->outputData('System class required to create server files');
            return false;
        }
        if (!file_exists($answers['docroot'])) {
            System::mkdir(array('-p', $answers['docroot']));
        }
        $answers['docroot'] = realpath($answers['docroot']);
        if (!$answers['docroot']) {
            $this->_ui->outputData('"' . $this->docroot . '" is not a valid path');
            return false;
        }
        $this->docroot = $answers['docroot'];
        $fp = @fopen($answers['docroot'] . DIRECTORY_SEPARATOR . 'channel.xml', 'w');
        if ($fp) {
            fwrite($fp, $this->channelxml);
            fclose($fp);
        } else {
            $this->_ui->outputData('Cannot open "' . $answers['docroot'] . DIRECTORY_SEPARATOR .
                'channel.xml" for writing');
            return false;
        }
        if (!file_exists($answers['docroot'] . DIRECTORY_SEPARATOR . 'get')) {
            System::mkdir(array('-p', $answers['docroot'] . DIRECTORY_SEPARATOR . 'get'));
        }
        @chmod($answers['docroot'] . DIRECTORY_SEPARATOR . 'get', 0777);
        // create xmlrpc.php
        $type = extension_loaded('mysqli') ? 'mysqli' : 'mysql';
        $config = 'array(\'database\'         => \'' .
            $type . '://' . $this->user . ':' . $this->password . '@localhost/' . $this->db . '\')';
        $contents = '<?php
require_once \'PEAR/Server.php\';
require_once \'PEAR/Server/Backend/DBDataObject.php\';
require_once \'PEAR/Server/Frontend/Xmlrpc5.php\';
$backend = new PEAR_Server_Backend_DBDataObject(\'' . $this->channel . '\', ' . $config . ');
$frontend = PEAR_Server_Frontend_Xmlrpc5::singleton(\'' . $this->channel . '\');
$server = new PEAR_Server(\'' . $answers['docroot'] . DIRECTORY_SEPARATOR . 'get' . '\');
$server->setBackend($backend);
$server->setFrontend($frontend);
$server->run();
?>';
        $fp = fopen($answers['docroot'] . DIRECTORY_SEPARATOR . 'xmlrpc.php', 'w');
        $a = fwrite($fp, $contents, strlen($contents));
        fclose($fp);
        if ($a) {
            $this->_ui->outputData('Successfully created ' .
                $answers['docroot'] . DIRECTORY_SEPARATOR . 'xmlrpc.php');
        } else {
            $this->_ui->outputData('Could not create ' .
                $answers['docroot'] . DIRECTORY_SEPARATOR . 'xmlrpc.php');
            return false;
        }

        // create frontend.php
        $type = extension_loaded('mysqli') ? 'mysqli' : 'mysql';
        $config = 'array(\'database\' => \'' .
            $type . '://' . $this->user . ':' . $this->password . '@localhost/' . $this->db . '\')';
        $contents = '<?php
require_once \'PEAR/Server.php\';
require_once \'PEAR/Server/Backend/DBDataObject.php\';
require_once \'PEAR/Server/Frontend/HTMLQuickForm.php\';
$backend = new PEAR_Server_Backend_DBDataObject(\'' . $this->channel . '\', ' . $config . ');
$frontend = new PEAR_Server_Frontend_HTMLQuickForm(\'' . $this->channel .
        '\', new HTML_QuickForm(\'channel\'),
        \'' . $answers['frontendphp'] . '\', \'' . $answers['uploadpath'] . '\');
$frontend->sessionStart();
$server = new PEAR_Server(\'' . $answers['docroot'] . DIRECTORY_SEPARATOR . 'get' . '\');
$server->setBackend($backend);
$server->setFrontend($frontend);
$server->run();
?>';
        $fp = fopen($answers['docroot'] . DIRECTORY_SEPARATOR . $answers['frontendphp'], 'w');
        $a = fwrite($fp, $contents, strlen($contents));
        fclose($fp);
        if ($a) {
            $this->_ui->outputData('Successfully created ' .
                $answers['docroot'] . DIRECTORY_SEPARATOR . $answers['frontendphp']);
        } else {
            $this->_ui->outputData('Could not create ' .
                $answers['docroot'] . DIRECTORY_SEPARATOR . $answers['frontendphp']);
            return false;
        }
        return true;
    }
}
?>