# Database : pearserver
# 

# --------------------------------------------------------

#
# Table structure for table channels
#

CREATE TABLE channels (
  channel varchar(100) NOT NULL default '',
  summary varchar(255) NOT NULL default '',
  alias varchar(100) NOT NULL default '',
  validatepackage varchar(255) default NULL,
  validatepackageversion varchar(25) default NULL,
  PRIMARY KEY  (channel)
);

# --------------------------------------------------------

#
# Table structure for table maintainers
#

CREATE TABLE maintainers (
  handle varchar(20) NOT NULL default '',
  channel varchar(25) NOT NULL default '',
  package varchar(80) NOT NULL default '',
  role varchar(30) NOT NULL default 'lead',
  active tinyint(4) NOT NULL default 'yes',
  PRIMARY KEY  (handle,channel,package)
);

# --------------------------------------------------------

#
# Table structure for table packages
#

CREATE TABLE packages (
  channel varchar(25) NOT NULL default '',
  package varchar(80) NOT NULL default '',
  license varchar(20) NOT NULL default '',
  licenseuri varchar(150) NOT NULL default '',
  summary text NOT NULL,
  description text NOT NULL,
  parent varchar(80),
  PRIMARY KEY  (channel,package)
);

# --------------------------------------------------------

#
# Table structure for table releases
#

CREATE TABLE releases (
  id int(11) NOT NULL default '0',
  channel varchar(25) NOT NULL default '',
  package varchar(80) NOT NULL default '',
  version varchar(20) NOT NULL default '',
  state enum('stable','beta','alpha','devel','snapshot') NOT NULL default 'stable',
  maintainer varchar(20) NOT NULL default '',
  license varchar(20) NOT NULL default '',
  summary text NOT NULL,
  description text NOT NULL,
  releasedate datetime NOT NULL,
  releasenotes text NOT NULL,
  filepath text NOT NULL,
  packagexml text NOT NULL,
  deps text NOT NULL,
  PRIMARY KEY  (id),
  KEY channel (channel,package),
  UNIQUE KEY version (channel,package,version)
);

# --------------------------------------------------------

#
# Table structure for table handles
#

CREATE TABLE handles (
  handle varchar(20) NOT NULL,
  name varchar(255) NOT NULL,
  email varchar(255) NOT NULL,
  password varchar(50) NOT NULL,
  admin INT(11) NOT NULL default 0,
  PRIMARY KEY (handle) 
);
